#include<iostream>
#include "bitmap.h"
#include<assert.h>
#include"ezwin.h"
#include"rect.h"
using namespace std;

//x,y are the width and height of the window

float x = 20.0;
float y= 16.0;
//defining the window
SimpleWindow snake("hello",x,y,Position(2.0,5.0));


//function for the animation of menu buttons
void moveup(SimpleWindow &win,BitMap &pic,float finalpos)
{
	float w,h;
	w = pic.GetWidth(); 	//getting the width of the picture
        h = pic.GetHeight();	//getting the height of the picture
	
	/* we move the image by erasing it and printing it at a new position.
	   we are erasing it by using black rectangles because our background is black.*/

	for(int i=0;.1*i<finalpos;i++)
	{	 
  	   win.RenderRectangle(Position(x/2-w/2,y-.1*(i-1)),Position(x/2+w,y+h-.1*(i-1)),Black);
	   pic.SetPosition(Position(x/2-w/2,y-.1*i));
	   pic.Draw();
	
	   /*empty loop for giving time lap between two consecutive images*/
	   for(int j=0;j<10000000/6;j++); 	
	 }
}

	


//function for the animation of name of the game
void animation(SimpleWindow &snake,BitMap &Serpent,float finalpos)
{float h1,w1;
	//getting width and height of the image of the "name of the game"
	w1 = Serpent.GetWidth();
	h1 = Serpent.GetHeight();
	Serpent.SetPosition(Position(x/2-w1/2,finalpos));	//setting the initial position of the image

		
	for(int i=0;i*0.01<h1/2;i++)
	 {    
		
		Serpent.Draw();

		/*drawing the rectangles to give animation effect to the image of name of the game
		we have used 4 rectangles, 2 of which are horizontal and the rest 2 vertical
		the height of the upper and lower horizontal rectangle decreases upwards and downwards respectively
		and the width of vertical rectagles decrease sideways outwards */

		snake.RenderRectangle (Position(x/2-w1/2,finalpos),Position(x/2+w1/2,finalpos+h1/2-i*.01),Black);	//upper rectangle
		snake.RenderRectangle(Position(x/2-w1/2,finalpos+i*.01+h1/2),Position(x/2+w1/2,finalpos+h1),Black);	//lower rectangle
		snake.RenderRectangle(Position(x/2-w1/2,finalpos),Position(x/2-w1/h1*.01*i,finalpos+h1),Black);		//left vertical rectangle
		snake.RenderRectangle(Position(x/2+i*w1/h1*.01,finalpos),Position(x/2+w1/2,finalpos+h1),Black);		//right vertical rectangle
	
		
		for(int j=0;j<10000000/6;j++); 	//delay loop
        }

	//for erasing the name of the game to make way for the menu buttons 
	for(int i=0;i<500000000;i++);
	Serpent.Erase();
	snake.RenderRectangle(Position(x/2-w1/2,finalpos),Position(x/2+w1/2,finalpos+h1),Black);
}


//function for the appearance of the image of snake
void MoveY(SimpleWindow &win,BitMap &Photo,float finalpos)
{ float w,h;
	w = Photo.GetWidth();
        h = Photo.GetHeight();
	Photo.SetPosition(Position(x/2-w/2,-h));
	//for loop for the sweep motion of the image
	for(int i=0;.02*i<finalpos;i++)
	{	 win.RenderRectangle(Position(x/2-w/2,-h+.02*(i-1)),Position(x/2+w,.02*(i-1)),Black);
	   	 Photo.SetPosition(Position(x/2-w/2,-h+.02*i));
	   	 Photo.Draw();
	   	 for(int j=0;j<10000000/6;j++);
	 }
}

BitMap m1(snake);
BitMap m2(snake);
BitMap m3(snake);
BitMap m4(snake);
BitMap m5(snake);
BitMap Photo(snake);
BitMap Serpent(snake);

//function of mouse click
int MouseClickEvent(const Position &MousePosition)
{
	if(m1.IsInside(MousePosition))
	{
	  cout<<"newgame"<<endl;	
	}

	if(m2.IsInside(MousePosition))
	{
	  cout<<"highscore"<<endl;
	}

	if(m3.IsInside(MousePosition))
	{
	  cout<<"instruction"<<endl;
	}

	if(m4.IsInside(MousePosition))
	{
	  cout<<"about"<<endl;
	}

	if(m5.IsInside(MousePosition))
	snake.Close();
	return 1;
}

//main function to invoke the functions defined above	
int ApiMain()
{       
	float h1,h2,h3,h4;
 	snake.Open();
	Photo.Load("snake.xpm");
	assert(Photo.GetStatus()== BitMapOkay);

	snake.RenderRectangle(Position(0,0),Position(x,y),Black);
  	MoveY(snake,Photo,7.0*y/20.0);

	Serpent.Load("serpent.xpm");
	assert(Photo.GetStatus()== BitMapOkay);
	animation(snake,Serpent,9.0*y/20);

	
	m1.Load("newgame.xpm");
        assert(Photo.GetStatus()== BitMapOkay);
	moveup(snake,m1,9.0*y/16);
	h1=m1.GetHeight();		

        m2.Load("highscore.xpm");
	assert(Photo.GetStatus()== BitMapOkay);
	moveup(snake,m2,9.0*y/16-h1);
	h2=m2.GetHeight();

        m3.Load("instructions.xpm");
	assert(Photo.GetStatus()== BitMapOkay);
	moveup(snake,m3,9.0*y/16-h1-h2);
	h3=m3.GetHeight();

	m4.Load("aboutgame.xpm");
	assert(Photo.GetStatus()== BitMapOkay);
	moveup(snake,m4,9.0*y/16-h1-h2-h3);
	h4=m4.GetHeight();
	
	m5.Load("quit.xpm");
	assert(Photo.GetStatus()== BitMapOkay);
	moveup(snake,m5,9.0*y/16-h1-h2-h3-h4);

	snake.SetMouseClickCallback(MouseClickEvent);
              
	return 0;
}
